#include <stdio.h>
#include "stack_0.h"

/* Question 3 */
/*@ requires s is a valid null-terminated string 
  assigns nothing
  ensures return the set computed from the string s */
set parse_string(char *s) {
  int i = 0;
  set a,b;
  stack p;
  init_stack(&p);
  while (s[i]) {
    if (s[i] >= 'a' && s[i] <= 'z') {
      a = empty_set();
      add_to_set(s[i], &a);
      push(a, &p);
    }
    else if (s[i] == '+') {
      a = pop(&p);
      b = pop(&p);
      push(set_union(a,b), &p);
    }
    else if (s[i] == '-') {
      a = pop(&p);
      b = pop(&p);
      push(set_difference(b,a), &p);
    }
    i += 1;
  }
  return pop(&p);
}

/* Question 4 */
int main() {
  char buf[256];
  set a, b;
  if (fgets(buf, 256, stdin) == NULL) {
    printf("Error reading the first line.\n");
    return 1;
  }
  a = parse_string(buf);
  if (fgets(buf, 256, stdin) == NULL) {
    printf("Error reading the second line.\n");
    return 2;
  }
  b = parse_string(buf);
  printf("Les ensembles ");
  print_set(a);
  printf(" et ");
  print_set(b);
  if (set_equal(a, b))
    printf(" sont égaux.\n");
  else
    printf(" ne sont pas égaux.\n");
  return 0;
}
    

    
  
