/* Question 1 */

/* elements of a set */
typedef char elem;

/* abstract type for sets */
typedef struct set_base *set;

/*@ requires nothing;
  assigns nothing;
  ensures returns an empty set */
set empty_set();

/*@ requires s points to a valid set 
  assigns *s
  ensures add e to *s, if e is already present in *s, do nothing */
void add_to_set(elem e, set *s);

/*@ requires s points to a valid set 
  assigns *s
  ensures remove e from *s, if e is not present in *s, do nothing */
void remove_from_set(elem e, set *s);

/*@ requires nothing
  assigns a and b
  ensures returns the union of a and b */
set set_union(set a, set b);

/*@ requires nothing
  assigns a and b
  ensures returns the difference of a by b */
set set_difference(set a, set b);

/*@ requires nothing
  assigns nothing
  ensures print s on the standard output */
void print_set(set s);

/*@ requires nothing
  assigns nothing
  ensures returns 1 if the sets are equal, 0 otherwise */
int set_equal(set a, set b);
