#ifndef _STACK_0_H  /* to avoid multiple inclusions */
#define _STACK_0_H
#include "set.h"

/* concrete type of the elements in the stack */
typedef set value;

/* abstract type of the stacks */
typedef struct impl_stack *stack;

/*@ requires s is a valid address (but not necessarily *s)
    assigns *s
    ensures initialize *s, *s is now the empty stack */
void init_stack(stack *s);

/*@ requires s is valid
    assigns nothing
    ensures returns 1 if s is empty, 0 otherwise */
int is_empty_stack(stack s);

/*@ requires s and *s are valid
    assigns *s
    ensures insert v into *s */
void push(value v, stack *s);

/*@ requires s and *s are valid, *s is not empty
    assigns *s
    ensures removes the value at the top of *s and returns it */
value pop(stack *s);

#endif
